// VizsgarendszerDoc.cpp : implementation of the CVizsgarendszerDoc class
//

#include "stdafx.h"
#include "Vizsgarendszer.h"
#include "VizsgarendszerDoc.h"
#include "Vizsgatargy_Felvetele_DLG.h"
#include "Vizsgatargy_Listazasa_DLG.h"
#include "Vizsgara_Jelentkezes_DLG.h"
#include "Vizsgazok_Listaja_DLG.h"
#include "Uzenet_DLG.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVizsgarendszerDoc

IMPLEMENT_DYNCREATE(CVizsgarendszerDoc, CDocument)

BEGIN_MESSAGE_MAP(CVizsgarendszerDoc, CDocument)
	//{{AFX_MSG_MAP(CVizsgarendszerDoc)
	ON_COMMAND(ID_VIZSGA_MEGHIRDETESE, OnVizsgaMeghirdetese)
	ON_COMMAND(ID_TARGYAK_LISTAZASA, OnTargyakListazasa)
	ON_UPDATE_COMMAND_UI(ID_TARGYAK_LISTAZASA, OnUpdateTargyakListazasa)
	ON_COMMAND(ID_VIZSGARA_JELENTKEZES, OnVizsgaraJelentkezes)
	ON_UPDATE_COMMAND_UI(ID_VIZSGARA_JELENTKEZES, OnUpdateVizsgaraJelentkezes)
	ON_COMMAND(ID_VIZSGAK_LISTAJA, OnVizsgakListaja)
	ON_UPDATE_COMMAND_UI(ID_VIZSGAK_LISTAJA, OnUpdateVizsgakListaja)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVizsgarendszerDoc construction/destruction

CVizsgarendszerDoc::CVizsgarendszerDoc()
{
//	dg = new Diagram();
}

CVizsgarendszerDoc::~CVizsgarendszerDoc()
{
}

BOOL CVizsgarendszerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CVizsgarendszerDoc serialization

void CVizsgarendszerDoc::Serialize(CArchive& ar)
{
	
	int n,i;

	if (ar.IsStoring())
	{
		// TODO: add storing code here
		n = vizsgatargyak_tombje.GetSize();
		ar.Write(&n, sizeof(int));
		for(i=0;i<n;i++){
			vizsgatargyak_tombje[i].Put(ar);
		}

		n = vizsgara_jelentkezettek_tombje.GetSize();
		ar.Write(&n, sizeof(int));
		for(i=0;i<n;i++){
			vizsgara_jelentkezettek_tombje[i].Put(ar);
		}
	}
	else
	{
		// TODO: add loading code here
		ar.Read(&n, sizeof(int));
		for(i=0;i<n;i++){
			Vizsga_Felvetel.Get(ar);
			vizsgatargyak_tombje.Add(Vizsga_Felvetel);
		}

		ar.Read(&n, sizeof(int));
		for(i=0;i<n;i++){
			Jelentkezes.Get(ar);
			vizsgara_jelentkezettek_tombje.Add(Jelentkezes);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVizsgarendszerDoc diagnostics

#ifdef _DEBUG
void CVizsgarendszerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVizsgarendszerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVizsgarendszerDoc commands

void CVizsgarendszerDoc::OnVizsgaMeghirdetese() 
{
	Vizsgatargy_Felvetele_DLG dlg;
	Vizsgatargy_Felvetele Vizsga_Felvetel;
	bool engedelyez = true;
	CString str = "Hiba!\n";
	
	if ( dlg.DoModal() == IDOK ){
		dlg.Get_Vizsgatargy_Felvetele(Vizsga_Felvetel);
		if ( Vizsga_Felvetel.Get_Vizsga_Helye().GetLength() < 1 ){
			str += "Nem rtl be VizsgaHelyet!\n";
			engedelyez = false;
		}
		if ( Vizsga_Felvetel.Get_Vizsgaztato().GetLength() < 1 ){
			str += "Nem rtl be Vizsgztatt!\n";
			engedelyez = false;
		}
		if ( Vizsga_Felvetel.Get_Targy_Neve().GetLength() < 1 ){
			str += "Nem rtl be Trgynevet!\n";
			engedelyez = false;
		}
		if ( Vizsga_Felvetel.Get_Max_Letszam() < 1 ){
			str += "Nem rtl be Maxltszmot!\n";
			engedelyez = false;
		}
		if ( Vizsga_Felvetel.Get_Vizsga_Ideje().GetStatus() != 0 ){
			str += "Rossz Vizsgaid!\n";
			engedelyez = false;
		}
		if ( engedelyez ){
			vizsgatargyak_tombje.Add(Vizsga_Felvetel);
			SetModifiedFlag(TRUE);
		} else {
			Uzenet_DLG uzenet_dlg;
			uzenet_dlg.Set_Uzenet(str);
			uzenet_dlg.DoModal();
		}
	}
}

void CVizsgarendszerDoc::OnTargyakListazasa() 
{
	Vizsgatargy_Listazasa_DLG dlg;
	dlg.SetDocument(this);
	dlg.DoModal();
}

void CVizsgarendszerDoc::OnUpdateTargyakListazasa(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(vizsgatargyak_tombje.GetSize() > 0);
}

int CVizsgarendszerDoc::GetSizeJelentkezettek() const
{
	return vizsgara_jelentkezettek_tombje.GetSize();
}

int CVizsgarendszerDoc::GetSizeTargyak() const
{
	return vizsgatargyak_tombje.GetSize();
}

void CVizsgarendszerDoc::OnVizsgaraJelentkezes() 
{
	Vizsgara_Jelentkezes_DLG dlg;
	dlg.SetDocument(this);
	dlg.DoModal();
}

void CVizsgarendszerDoc::OnUpdateVizsgaraJelentkezes(CCmdUI* pCmdUI) 
{
	bool engedelyez = false;

	for(int i=0; i<vizsgatargyak_tombje.GetSize(); i++){
		if ( vizsgatargyak_tombje[i].Get_Max_Letszam() - vizsgatargyak_tombje[i].Get_Eddigi_Letszam() > 0 ){
			engedelyez = true;
			break;
		}
	}
	pCmdUI->Enable( engedelyez );
}

void CVizsgarendszerDoc::OnVizsgakListaja() 
{
	Vizsgazok_Listaja_DLG dlg;
	dlg.SetDocument(this);
	dlg.DoModal();
}

void CVizsgarendszerDoc::OnUpdateVizsgakListaja(CCmdUI* pCmdUI) 
{
	bool engedelyez = false;

	for(int i=0; i<vizsgatargyak_tombje.GetSize(); i++){
		if ( GetSizeJelentkezettek() > 0 ){
			engedelyez = true;
			break;
		}
	}
	pCmdUI->Enable( engedelyez );
}
